﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.82
@EndOfDesignText@
'Custom View class
#Event: ExampleEvent (Value As Int)
#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private lblSlider As Label
	Private MySlider As RangeSlider
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	lblSlider.Initialize("")
	MySlider.Initialize("aSlider")
End Sub

Public Sub DesignerCreateView (Base As Pane, lbl As Label, Props As Map)
	mBase = Base
	mBase.PrefHeight = Max(90dip, Base.Height)
	mBase.AddNode(lblSlider,10dip,10dip,mBase.Width-20dip,20dip)
	
	MySlider.MajorTickUnit = 1.0
	MySlider.MinorTickCount = 3
	MySlider.HighValue = 18.0
	MySlider.LowValue = 8.0
	MySlider.MaxValue = 20
	MySlider.MinValue = 7
	MySlider.ShowTickLabels = True
	MySlider.ShowTickMarks = True
	MySlider.SnapToTicks = True
	mBase.AddNode(MySlider,10dip,30dip,-1,40dip)
	CallSubDelayed3(Me,"Base_Resize",mBase.PrefWidth,mBase.PrefHeight)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	lblSlider.Top=10dip
	MySlider.SetSize(Width-20dip, Height-lblSlider.Height-30dip)
	MySlider.Top = lblSlider.Top+lblSlider.Height+10dip
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

Private Sub aSlider_ValueChange (LowValue As Double, HighValue As Double)
	Dim hw,lw As Double
	lw = Floor(Round2(LowValue,2))
	hw = Floor(Round2(HighValue,2))
	Dim t(2) As Int
	t(0) = (LowValue*100) Mod 100
	t(1) = (HighValue*100) Mod 100
	For j = 0 To 1
		Select True
			Case t(j)>0 And t(j)<=25
				t(j) = 15
			Case t(j)>=26 And t(j)<=50
				t(j) = 30
			Case t(j)>=51 And t(j)<=75
				t(j) = 45
			Case t(j)>=76
				t(j)=0
				If j = 0 Then lw = lw+1 Else hw=hw+1
		End Select
	Next
	lblSlider.text=$"$2.0{lw}:${NumberFormat(t(0),2,0)}-$1.0{hw}:${NumberFormat(t(1),2,0)}"$
End Sub

'Setta il valore minimo dello slider
public Sub setLowValue(value As Int)
	MySlider.LowValue = value
End Sub

'Setta il valore massimo dello slider
public Sub setHighValue(value As Int)
	MySlider.HighValue = value
End Sub

'Setta il valore minimo del range
public Sub setMinValue(value As Double)
	MySlider.MinValue = value
End Sub

'Setta il valore massimo del range
public Sub setMaxValue(value As Double)
	MySlider.MaxValue = value
End Sub

'Ritorna HighValue nel formato hh:mm
public Sub GetHighValueStr As String
	Return GeHLValueStr(MySlider.HighValue)
End Sub

'Ritorna LowValue nel formato hh:mm
public Sub GetLowValueStr As String
	Return GeHLValueStr(MySlider.LowValue)
End Sub

'Ritorna il valore passato nel formato hh:mm con minuti normalizzati a 00,15,30 e 45
Private Sub GeHLValueStr(Value As Double) As String
	Dim hw As Double
	hw = Floor(Round2(Value,2))
	Dim t As Int
	t = (Value*100) Mod 100
	Select True
		Case t>0 And t<=25
			t = 15
		Case t>=26 And t<=50
			t = 30
		Case t>=51 And t<=75
			t= 45
		Case t>=76
			t=0
			hw=hw+1
	End Select
	Return $"$2.0{hw}:${NumberFormat(t,2,0)}"$
End Sub
